package com.usky.fire.service.util;

import com.usky.fire.domain.PatrolInspectionArea;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class OnlineMethod {

    /**
     * 根据父节点的ID获取所有子节点
     *
     * @param list 分类表
     * @param parentId 传入的父节点ID
     * @return String
     */
    public List<PatrolInspectionArea> getChildPerms(List<PatrolInspectionArea> list, int parentId)
    {
        List<PatrolInspectionArea> returnList = new ArrayList<PatrolInspectionArea>();
        for (Iterator<PatrolInspectionArea> iterator = list.iterator(); iterator.hasNext();)
        {
            PatrolInspectionArea t = (PatrolInspectionArea) iterator.next();
            // 一、根据传入的某个父节点ID,遍历该父节点的所有子节点
            if (t.getAreaFid() == parentId)
            {
                recursionFn(list, t);
                returnList.add(t);
            }
        }
        return returnList;
    }

    /**
     * 递归列表
     *
     * @param list
     * @param t
     */
    private void recursionFn(List<PatrolInspectionArea> list, PatrolInspectionArea t)
    {
        // 得到子节点列表
        List<PatrolInspectionArea> childList = getChildList(list, t);
        t.setChildren(childList);
        for (PatrolInspectionArea tChild : childList)
        {
            if (hasChild(list, tChild))
            {
                recursionFn(list, tChild);
            }
        }
    }


    /**
     * 得到子节点列表
     */
    private List<PatrolInspectionArea> getChildList(List<PatrolInspectionArea> list, PatrolInspectionArea t)
    {
        List<PatrolInspectionArea> tlist = new ArrayList<PatrolInspectionArea>();
        Iterator<PatrolInspectionArea> it = list.iterator();
        while (it.hasNext())
        {
            PatrolInspectionArea n = (PatrolInspectionArea) it.next();
            if (n.getAreaFid().longValue() == t.getId().longValue())
            {
                tlist.add(n);
            }
        }
        return tlist;
    }


    /**
     * 判断是否有子节点
     */
    private boolean hasChild(List<PatrolInspectionArea> list, PatrolInspectionArea t)
    {
        return getChildList(list, t).size() > 0 ? true : false;
    }

}
